#ifndef DEBUG_H_INCLUDED
#define DEBUG_H_INCLUDED

#ifdef DEBUG

	#include <stdio.h>

	/* инициализируются в debug.c */
	extern char
		DEBUG_PIPE_SYS,
		DEBUG_PIPE_TMP,
		DEBUG_PIPE_WRNG,
		DEBUG_PIPE_FIXME,
		DEBUG_PIPE_KEY,
		DEBUG_PIPE_FOCUS,
		DEBUG_PIPE_MOTION;

	#define DBG( ... ) __VA_ARGS__
	#define RLS( ... )
	#define ASSERT( x ) do \
		if (!(x)) \
		{ \
			printf("%s:%i: assertion \"%s\" failed\nWhat do you want? (Continue - c, Break - b, Abort - a, Exit - e) ", \
				__FILE__, __LINE__, #x); \
			switch (getc(stdin)) \
			{ \
				case 'e': exit(1); \
				case 'a': abort(); \
				case 'b': __asm__ __volatile__ ("int $3"); \
				case '\n': break; \
				default: while (getc(stdin)!='\n'); \
			} \
		}while(0)

	#define DBGPRINT( pipe, x ) do{if (DEBUG_PIPE_##pipe) printf("%s: %s%c", #pipe, x, '\n');}while(0)
	#define DBGFLPRINT( pipe, x ) do{if (DEBUG_PIPE_##pipe) printf("%s: %s:%i: %s%c", #pipe, __FILE__, __LINE__, x, '\n');}while(0)
	#define DBGPRINTF( pipe, ... ) do{if (DEBUG_PIPE_##pipe) {printf("%s: ", #pipe); printf(__VA_ARGS__); puts("");}}while(0)
	#define DBGFLPRINTF( pipe, ... ) do{if (DEBUG_PIPE_##pipe) {printf("%s: %s:%i: ", #pipe, __FILE__, __LINE__); printf(__VA_ARGS__); puts("");}}while(0)

#else

	#define DBG( ... )
	#define RLS( ... ) __VA_ARGS__
	#define ASSERT( x )
	#define DBGPRINT( pipe, x )
	#define DBGFLPRINT( pipe, x )
	#define DBGPRINTF( pipe, ... )
	#define DBGFLPRINTF( pipe, ... )

#endif

#endif /* DEBUG_H_INCLUDED */
