#include <stdlib.h>
#include <GL/gl.h>
#include "engine.h"
#include "debug.h"

#define ANGULAR_VELOCITY(x) x*(engine_time % (x*360000ULL))/1000000000.0

GLfloat k = 0.1;
unsigned long long w_pressed_time, s_pressed_time;

void drawing_function()
{
	if (engine_keys_states[engine_kc_w] == engine_sc_key_down)
	{
		k += (engine_time - w_pressed_time)*0.000001;
		w_pressed_time = engine_time;
	}
	if (engine_keys_states[engine_kc_s] == engine_sc_key_down)
	{
		k -= (engine_time - s_pressed_time)*0.000001;
		s_pressed_time = engine_time;
	}
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	glClear(GL_COLOR_BUFFER_BIT);
	glPushMatrix();
	glRotatef(ANGULAR_VELOCITY(10000), 0.0f, 0.0f, 1.0f);
	glBegin(GL_TRIANGLES);
	glColor3ub(255, 0, 0); glVertex2f(0.0f, k);
	glColor3ub(0, 255, 0); glVertex2f(0.5, -0.5);
	glColor3ub(0, 0, 255); glVertex2f(-0.5, -0.5);
	glEnd();
	glPopMatrix();
}

void keys_handler(unsigned keycode, int x, int y, char state_flag)
{
	if (state_flag == engine_sc_key_down)
		switch (keycode)
		{
			case engine_kc_w:
				w_pressed_time = engine_time;
			break;
			case engine_kc_s:
				s_pressed_time = engine_time;
			break;
		}
	else
		switch (keycode)
		{
			case engine_kc_w:
				k += (engine_time - w_pressed_time)*0.0000001;
			break;
			case engine_kc_s:
				k -= (engine_time - s_pressed_time)*0.0000001;
			break;
			case engine_kc_f5:
				engine_set_mode(640, 480, 16, 0);
			break;
			case engine_kc_f6:
				engine_set_mode(640, 480, 24, 0);
			break;
			case engine_kc_f7:
				engine_set_mode(800, 600, 24, 0);
			break;
			case engine_kc_f8:
				engine_set_mode(800, 600, 24, 1);
			break;
		}
}

void motion_handler(int x, int y)
{
}

void focus_handler(char state)
{
}

int main()
{
	#include "icon.h"
	engine_set_title("Программа");
	engine_set_icon(icon_data, icon_data_length);
	engine_set_keys_handler(keys_handler);
	engine_set_drawing_function(drawing_function);
	engine_set_max_fps(25);
	engine_set_mode(800, 600, 24, 1);
	engine_set_motion_handler(motion_handler);	
	engine_set_focus_handler(focus_handler);
	engine_init();
	engine_main_loop();
	return 0;
}
