#!/bin/sh

if test $# -ne 2 && test $# -ne 3; then
	echo 'Usage: sh rgba2c.sh infile outfile [arrayname]'
	exit 1
fi

wh=$(echo "sqrt($(ls -l $1 | cut -d' ' -f5)/4)" | bc)

if test $# -eq 3; then
	arrayname=$3
else
	arrayname=data
fi
echo -en "unsigned long $arrayname[] =\n{\n\t$wh, $wh" > $2

xxd -g1 -c4 $1 | awk -v wh=$wh '
{
	if ((NR-1) % wh == 0)
		printf(",\n\t");
	else
		printf(", ");
	printf("0x%s%s%s%s", $5, $2, $3, $4);
}
' >> $2

echo -e "\n};
int icon_data_length = sizeof($arrayname)/sizeof(unsigned long);" >> $2
